/*
 * Robert Lembree, lembree@metrolink.com
 * Copyright (C) 2001 Metro Link, Inc.  All rights reserved.
 *
 * ########################################################################
 *
 *  This program is free software; you can distribute it and/or modify it
 *  under the terms of the GNU General Public License (Version 2) as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 * ########################################################################
 */

#include <linux/config.h>
#include <asm/reboot.h>
#include <asm/ati/xilleon.h>

static void xilleon_restart(char *command)
{
	int cntl_val = GETREG_REGMM32(MIPS_CNTL);
    int r;
   
	printk("Warm reset\n");

#ifdef CONFIG_MTD_NAND_STWX225
    pflash_clear_state_machine(10);
    r = GETREG_REGMM32(PFLASH_CNTL);
    MODIFYFLD(r, PFLASH_CNTL, PF32MBIT_EN, 1);
    MODIFYFLD(r, PFLASH_CNTL, PF64MBIT_EN, 0);
    MODIFYFLD(r, PFLASH_CNTL, PF128MBIT_EN, 0); 
    SETREG_REGMM32(PFLASH_CNTL, r);
#endif
   
	MODIFYFLD(cntl_val, MIPS_CNTL, WARM_RESET, 1);

	SETREG_REGMM32(MIPS_CNTL, cntl_val);
	set_c0_status(ST0_BEV | ST0_ERL);
	set_c0_config(CONF_CM_UNCACHED);
	flush_cache_all();
	write_c0_wired(0);
	__asm__ __volatile__("jr\t%0"::"r"(0xbfc00000));
	while(1);
}

static void xilleon_halt(void)
{
	int cntl_val = GETREG_REGMM32(MIPS_CNTL);

	printk("Cold reset\n");

	MODIFYFLD(cntl_val, MIPS_CNTL, COLD_RESET, 1);

	SETREG_REGMM32(MIPS_CNTL, cntl_val);
	while(1);
}


void xilleon_reboot_setup(void)
{
	_machine_restart = xilleon_restart;
	_machine_halt = xilleon_halt;
	_machine_power_off = xilleon_halt;
}
