/*
 * linux/arch/mips/tc90400/gdrs_board/gdrs_board_irq.c : Reference No : 43PJ292-20050906-QFP_BOARD01-000
 *
 * Internal driver for TC90400
 *
 *  (c) Copyright TOSHIBA CORPORATION SEMICONDUCTOR COMPANY  2003-2005 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 *
 */
/*
 * linux/arch/mips/tx4927/toshiba_rbtx4927/toshiba_rbtx4927_irq.c
 *
 * Toshiba RBTX4927 specific interrupt handlers
 *
 * Author: MontaVista Software, Inc.  source@mvista.com
 *
 * 2003 (c) MontaVista Software, Inc. This file is licensed under
 * the terms of the GNU General Public License version 2. This program 
 * is licensed "as is" without any warranty of any kind, whether express 
 * or implied.
 */

/*
IRQ  Device  
00   TC90400-CP0/00 Software 0
01   TC90400-CP0/01 Software 1
02   TC90400-CP0/02 Multiplexed -- do not use 
03   TC90400-CP0/03 Multiplexed -- do not use 
04   TC90400-CP0/04 Multiplexed -- do not use 
05   TC90400-CP0/05 Multiplexed -- do not use 
06   TC90400-CP0/06 Multiplexed -- do not use 
07   TC90400-CP0/07 Cascade TC90400-PIC

08   TC90400-PIC/00
09   TC90400-PIC/01 EXTINT0(FPGA0 Chip board)
10   TC90400-PIC/02 EXTINT1(FPGA1 Main board)  
11   TC90400-PIC/03 EXTINT2
12   TC90400-PIC/04 MPIF-CommonInterface
13   TC90400-PIC/05 MPIF-ATA
14   TC90400-PIC/06 MPIF-NandFlash
15   TC90400-PIC/07 GMBR
16   TC90400-PIC/08 GFX
17   TC90400-PIC/09 VIOU TX IRQ
18   TC90400-PIC/10 SCC ch.0
19   TC90400-PIC/11 SCC ch.1
20   TC90400-PIC/12 USB
21   TC90400-PIC/13 ALOC ch.0
22   TC90400-PIC/14 ALOC ch.1
23   TC90400-PIC/15 DMAC ch.0
24   TC90400-PIC/16 DMAC ch.1
25   TC90400-PIC/17 DMAC ch.2
26   TC90400-PIC/18 DMAC ch.3
27   TC90400-PIC/19 I2C ch.1
28   TC90400-PIC/20 SIO ch.0
29   TC90400-PIC/21 SIO ch.1
30   TC90400-PIC/22 SIO ch.2
31   TC90400-PIC/23 RTC C
32   TC90400-PIC/24 RTC WU
33   TC90400-PIC/25 PIO
34   TC90400-PIC/26 I2C ch.0
35   TC90400-PIC/27 Timer ch.3
36   TC90400-PIC/28 Timer ch.0
37   TC90400-PIC/29 Timer ch.1
38   TC90400-PIC/30 Timer ch.2
39   TC90400-PIC/31 GBUS

40   TC90400GDRS-FPGA0/00
41   TC90400GDRS-FPGA0/01
42   TC90400GDRS-FPGA0/02
43   TC90400GDRS-FPGA0/03
44   TC90400GDRS-FPGA0/04
45   TC90400GDRS-FPGA0/05
46   TC90400GDRS-FPGA0/06
47   TC90400GDRS-FPGA0/07
48   TC90400GDRS-FPGA0/08
49   TC90400GDRS-FPGA0/09
50   TC90400GDRS-FPGA0/10
51   TC90400GDRS-FPGA0/11
52   TC90400GDRS-FPGA0/12
53   TC90400GDRS-FPGA0/13
54   TC90400GDRS-FPGA0/14
55   TC90400GDRS-FPGA0/15

56   TC90400GDRS-FPGA1/00
57   TC90400GDRS-FPGA1/01
58   TC90400GDRS-FPGA1/02
59   TC90400GDRS-FPGA1/03
60   TC90400GDRS-FPGA1/04
61   TC90400GDRS-FPGA1/05
62   TC90400GDRS-FPGA1/06
63   TC90400GDRS-FPGA1/07
64   TC90400GDRS-FPGA1/08
65   TC90400GDRS-FPGA1/09
66   TC90400GDRS-FPGA1/10
67   TC90400GDRS-FPGA1/11
68   TC90400GDRS-FPGA1/12
69   TC90400GDRS-FPGA1/13
70   TC90400GDRS-FPGA1/14
71   TC90400GDRS-FPGA1/15

NOTES:
FPGA0/00,02,07-15:Reserved
FPGA0/01:HDMI RX
FPGA0/03:Card Controller
FPGA0/04:POD Controller
FPGA0/05:Product LAN(LAN91C111)
FPGA0/06:Common Interface

FPGA1/00:SD Card Controller
FPGA1/01:AV Output Board
FPGA1/02:Tuner Board
FPGA1/03:HDMI RX
FPGA1/04:HDMI TX
FPGA1/05:LAN91C111
FPGA1/06:MB86619C
FPGA1/07:TC90700 A-Mute
FPGA1/08:TC90700 RX portA
FPGA1/09:TC90700 RX portB
FPGA1/10-15:Reserved
*/

#include <linux/config.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/mm.h>
#include <linux/swap.h>
#include <linux/ioport.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/pci.h>
#include <linux/timex.h>
#include <asm/bootinfo.h>
#include <asm/page.h>
#include <asm/bootinfo.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/pci.h>
#include <asm/processor.h>
#include <asm/ptrace.h>
#include <asm/reboot.h>
#include <asm/time.h>
#include <linux/version.h>
#include <linux/bootmem.h>
#include <linux/blk.h>
#include <asm/tc90400/tc90400gdrs.h>


#undef TOSHIBA_TC90400GDRS_IRQ_DEBUG

#ifdef TOSHIBA_TC90400GDRS_IRQ_DEBUG
#define TOSHIBA_TC90400GDRS_IRQ_NONE        0x00000000

#define TOSHIBA_TC90400GDRS_IRQ_INFO          ( 1 <<  0 )
#define TOSHIBA_TC90400GDRS_IRQ_WARN          ( 1 <<  1 )
#define TOSHIBA_TC90400GDRS_IRQ_EROR          ( 1 <<  2 )

#define TOSHIBA_TC90400GDRS_IRQ_FPGA_INIT      ( 1 << 10 )
#define TOSHIBA_TC90400GDRS_IRQ_FPGA_STARTUP   ( 1 << 11 )
#define TOSHIBA_TC90400GDRS_IRQ_FPGA_SHUTDOWN  ( 1 << 12 )
#define TOSHIBA_TC90400GDRS_IRQ_FPGA_ENABLE    ( 1 << 13 )
#define TOSHIBA_TC90400GDRS_IRQ_FPGA_DISABLE   ( 1 << 14 )
#define TOSHIBA_TC90400GDRS_IRQ_FPGA_MASK      ( 1 << 15 )
#define TOSHIBA_TC90400GDRS_IRQ_FPGA_ENDIRQ    ( 1 << 16 )

#define TOSHIBA_TC90400GDRS_SETUP_ALL         0xffffffff
#endif


#ifdef TOSHIBA_TC90400GDRS_IRQ_DEBUG
static const u32 tc90400gdrs_irq_debug_flag =
    (TOSHIBA_TC90400GDRS_IRQ_NONE | TOSHIBA_TC90400GDRS_IRQ_INFO |
     TOSHIBA_TC90400GDRS_IRQ_WARN | TOSHIBA_TC90400GDRS_IRQ_EROR
//   | TOSHIBA_TC90400GDRS_IRQ_FPGA_INIT  
//   | TOSHIBA_TC90400GDRS_IRQ_FPGA_STARTUP  
//   | TOSHIBA_TC90400GDRS_IRQ_FPGA_SHUTDOWN  
//   | TOSHIBA_TC90400GDRS_IRQ_FPGA_ENABLE  
//   | TOSHIBA_TC90400GDRS_IRQ_FPGA_DISABLE  
//   | TOSHIBA_TC90400GDRS_IRQ_FPGA_MASK  
//   | TOSHIBA_TC90400GDRS_IRQ_FPGA_ENDIRQ  
    );
#endif

#ifdef TOSHIBA_TC90400GDRS_IRQ_DEBUG
#define TOSHIBA_TC90400GDRS_IRQ_DPRINTK(flag,str...) \
        if ( (tc90400gdrs_irq_debug_flag) & (flag) ) \
        { \
           char tmp[100]; \
           sprintf( tmp, str ); \
           printk( "%s(%s:%u)::%s", __FUNCTION__, __FILE__, __LINE__, tmp ); \
        }
#else
#define TOSHIBA_TC90400GDRS_IRQ_DPRINTK(flag,str...)
#endif


static unsigned int tc90400gdrs_irq_fpga_startup(unsigned int irq);
static void tc90400gdrs_irq_fpga_shutdown(unsigned int irq);
static void tc90400gdrs_irq_fpga_enable(unsigned int irq);
static void tc90400gdrs_irq_fpga_disable(unsigned int irq);
static void tc90400gdrs_irq_fpga_mask_and_ack(unsigned int irq);
static void tc90400gdrs_irq_fpga_end(unsigned int irq);

static spinlock_t tc90400gdrs_irq_fpga_lock = SPIN_LOCK_UNLOCKED;


#define TC90400GDRS_FPGA0_NAME "TC90400GDRS-FPGA0"
static struct hw_interrupt_type tc90400gdrs_irq_fpga0_type = {
	typename:TC90400GDRS_FPGA0_NAME,
	startup :tc90400gdrs_irq_fpga_startup,
	shutdown:tc90400gdrs_irq_fpga_shutdown,
	enable  :tc90400gdrs_irq_fpga_enable,
	disable :tc90400gdrs_irq_fpga_disable,
	ack     :tc90400gdrs_irq_fpga_mask_and_ack,
	end     :tc90400gdrs_irq_fpga_end,
	set_affinity:NULL
};
#define TC90400GDRS_FPGA1_NAME "TC90400GDRS-FPGA1"
static struct hw_interrupt_type tc90400gdrs_irq_fpga1_type = {
	typename:TC90400GDRS_FPGA1_NAME,
	startup :tc90400gdrs_irq_fpga_startup,
	shutdown:tc90400gdrs_irq_fpga_shutdown,
	enable  :tc90400gdrs_irq_fpga_enable,
	disable :tc90400gdrs_irq_fpga_disable,
	ack     :tc90400gdrs_irq_fpga_mask_and_ack,
	end     :tc90400gdrs_irq_fpga_end,
	set_affinity:NULL
};


u32 bit2num(u32 num)
{
	u32 i;

	for (i = 0; i < (sizeof(num) * 8); i++) {
		if (num & (1 << i)) {
			return (i);
		}
	}
	return (0);
}

int tc90400gdrs_irq_nested(int sw_irq)
{
	u32 level3;

	if (sw_irq == TC90400_IRQ_EXT0) {
#ifdef CONFIG_TOSHIBA_TC90400_QFP
            level3  = TC90400_RD08(TC90400GDRS_FPGA0_INT_STAT) & TC90400_RD08(TC90400GDRS_FPGA0_INT_MASK);
#else
            level3  = TC90400_RD16(TC90400GDRS_FPGA0_INT_STAT) & TC90400_RD16(TC90400GDRS_FPGA0_INT_MASK);
#endif /* #ifdef CONFIG_TOSHIBA_TC90400_QFP */
            level3 &= FPGA0_INTMASK_ALLMASK;
	    if (level3) {
		sw_irq = TC90400GDRS_IRQ_FPGA0_BEG + bit2num(level3);
	    }
	    else {
		sw_irq = 0;
	    }
	}
	else if (sw_irq == TC90400_IRQ_EXT1) {
#ifdef CONFIG_TOSHIBA_TC90400_QFP
            level3 = (TC90400_RD08(TC90400GDRS_FPGA1_INT_STAT1) & TC90400_RD08(TC90400GDRS_FPGA1_INT_MASK1));
            level3 |= ((TC90400_RD08(TC90400GDRS_FPGA1_INT_STAT2) & TC90400_RD08(TC90400GDRS_FPGA1_INT_MASK2)) << 8);
#else
            level3 = (TC90400_RD16(TC90400GDRS_FPGA1_INT_STAT) & TC90400_RD16(TC90400GDRS_FPGA1_INT_MASK));
#endif /* #ifdef CONFIG_TOSHIBA_TC90400_QFP */
            level3 &= FPGA1_INTMASK_ALLMASK;
	    if (level3) {
		sw_irq = TC90400GDRS_IRQ_FPGA1_BEG + bit2num(level3);
	    }
	    else {
		sw_irq = 0;
	    }
	}
	return (sw_irq);
}

//#define TC90400GDRS_PIC_ACTION(s) { no_action, 0, 0, s, NULL, NULL }
#define TC90400GDRS_PIC_ACTION(s) { no_action, SA_SHIRQ, 0, s, NULL, NULL }
static struct irqaction tc90400gdrs_irq_fpga0_action =
TC90400GDRS_PIC_ACTION(TC90400GDRS_FPGA0_NAME);
static struct irqaction tc90400gdrs_irq_fpga1_action =
TC90400GDRS_PIC_ACTION(TC90400GDRS_FPGA1_NAME);


/***************************************************************************/
/* Functions for fpga                                                      */
/***************************************************************************/

static void __init tc90400gdrs_irq_fpga_init(void)
{
	int i;


	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_FPGA_INIT,
				     "beg=%d end=%d\n",
				     TC90400GDRS_IRQ_FPGA0_BEG,
				     TC90400GDRS_IRQ_FPGA0_END);
        /* init fpga0 (chip board) */
	for (i = TC90400GDRS_IRQ_FPGA0_BEG;
	     i <= TC90400GDRS_IRQ_FPGA0_END; i++) {
		irq_desc[i].status = IRQ_DISABLED;
		irq_desc[i].action = 0;
		irq_desc[i].depth = 3;
		irq_desc[i].handler = &tc90400gdrs_irq_fpga0_type;
	}
	setup_irq(TC90400GDRS_IRQ_NEST_FPGA0_ON_PIC,
		  &tc90400gdrs_irq_fpga0_action); /* TC90400_IRQ_EXT0 */

	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_FPGA_INIT,
				     "beg=%d end=%d\n",
				     TC90400GDRS_IRQ_FPGA1_BEG,
				     TC90400GDRS_IRQ_FPGA1_END);

        /* init fpga1 (main board) */
	for (i = TC90400GDRS_IRQ_FPGA1_BEG;
	     i <= TC90400GDRS_IRQ_FPGA1_END; i++) {
		irq_desc[i].status = IRQ_DISABLED;
		irq_desc[i].action = 0;
		irq_desc[i].depth = 3;
		irq_desc[i].handler = &tc90400gdrs_irq_fpga1_type;
	}
	setup_irq(TC90400GDRS_IRQ_NEST_FPGA1_ON_PIC,
		  &tc90400gdrs_irq_fpga1_action); /* TC90400_IRQ_EXT1 */

	return;
}

static unsigned int tc90400gdrs_irq_fpga_startup(unsigned int irq)
{
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_FPGA_STARTUP,
				     "irq=%d\n", irq);

	tc90400gdrs_irq_fpga_enable(irq);

	return (0);
}


static void tc90400gdrs_irq_fpga_shutdown(unsigned int irq)
{
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_FPGA_SHUTDOWN,
				     "irq=%d\n", irq);

	tc90400gdrs_irq_fpga_disable(irq);

	return;
}


static void tc90400gdrs_irq_fpga_enable(unsigned int irq)
{
	unsigned long flags;
	volatile unsigned short v;

	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_FPGA_ENABLE,
				     "irq=%d\n", irq);

	if (irq >= TC90400GDRS_IRQ_FPGA0_BEG
	    && irq <= TC90400GDRS_IRQ_FPGA0_END) { /* check irq no.40-55 */

	    spin_lock_irqsave(&tc90400gdrs_irq_fpga_lock, flags);
#ifdef CONFIG_TOSHIBA_TC90400_QFP
	    v = TC90400_RD08(TC90400GDRS_FPGA0_INT_MASK);
	    v |= (1 << (irq - TC90400GDRS_IRQ_FPGA0_BEG));
	    TC90400GDRS_WR08(TC90400GDRS_FPGA0_INT_MASK, v);
#else
	    v = TC90400_RD16(TC90400GDRS_FPGA0_INT_MASK);
	    v |= (1 << (irq - TC90400GDRS_IRQ_FPGA0_BEG));
	    TC90400GDRS_WR16(TC90400GDRS_FPGA0_INT_MASK, v);
#endif /* #ifdef CONFIG_TOSHIBA_TC90400_QFP */
	    spin_unlock_irqrestore(&tc90400gdrs_irq_fpga_lock, flags);
	}
        else if (irq >= TC90400GDRS_IRQ_FPGA1_BEG
	    && irq <= TC90400GDRS_IRQ_FPGA1_END) { /* check irq no.56-71 */

	    spin_lock_irqsave(&tc90400gdrs_irq_fpga_lock, flags);
#ifdef CONFIG_TOSHIBA_TC90400_QFP
	    if (irq <  (TC90400GDRS_IRQ_FPGA1_BEG + 8)) {
	        v = TC90400_RD08(TC90400GDRS_FPGA1_INT_MASK1);
	        v |= (1 << (irq - TC90400GDRS_IRQ_FPGA1_BEG));
	        TC90400GDRS_WR08(TC90400GDRS_FPGA1_INT_MASK1, v);
	    }
	    else {
	        v = TC90400_RD08(TC90400GDRS_FPGA1_INT_MASK2);
	        v |= (1 << (irq - (TC90400GDRS_IRQ_FPGA1_BEG+8)));
	        TC90400GDRS_WR08(TC90400GDRS_FPGA1_INT_MASK2, v);
	    }
#else
	    v = TC90400_RD16(TC90400GDRS_FPGA1_INT_MASK);
	    v |= (1 << (irq - TC90400GDRS_IRQ_FPGA1_BEG));
	    TC90400GDRS_WR16(TC90400GDRS_FPGA1_INT_MASK, v);
#endif /* #ifdef CONFIG_TOSHIBA_TC90400_QFP */
	    spin_unlock_irqrestore(&tc90400gdrs_irq_fpga_lock, flags);
	}
        else {
		TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_EROR,
					     "bad irq=%d\n", irq);
		panic("\n");
	}

	return;
}


static void tc90400gdrs_irq_fpga_disable(unsigned int irq)
{
	unsigned long flags;
	volatile unsigned short v;

	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_FPGA_DISABLE,
				     "irq=%d\n", irq);

	if (irq >= TC90400GDRS_IRQ_FPGA0_BEG
	    && irq <= TC90400GDRS_IRQ_FPGA0_END) { /* check irq no.40-55 */

	    spin_lock_irqsave(&tc90400gdrs_irq_fpga_lock, flags);
#ifdef CONFIG_TOSHIBA_TC90400_QFP
	    v = TC90400_RD08(TC90400GDRS_FPGA0_INT_MASK);
	    v &= ~(1 << (irq - TC90400GDRS_IRQ_FPGA0_BEG));
	    TC90400GDRS_WR08(TC90400GDRS_FPGA0_INT_MASK, v);
            v = ~(1 << (irq - TC90400GDRS_IRQ_FPGA0_BEG)); /* 0 clear */
	    TC90400GDRS_WR08(TC90400GDRS_FPGA0_INT_CLEAR, v);
#else
	    v = TC90400_RD16(TC90400GDRS_FPGA0_INT_MASK);
	    v &= ~(1 << (irq - TC90400GDRS_IRQ_FPGA0_BEG));
	    TC90400GDRS_WR16(TC90400GDRS_FPGA0_INT_MASK, v);
            v = ~(1 << (irq - TC90400GDRS_IRQ_FPGA0_BEG)); /* 0 clear */
	    TC90400GDRS_WR16(TC90400GDRS_FPGA0_INT_CLEAR, v);
#endif /* #ifdef CONFIG_TOSHIBA_TC90400_QFP */
	    spin_unlock_irqrestore(&tc90400gdrs_irq_fpga_lock, flags);
	}
        else if (irq >= TC90400GDRS_IRQ_FPGA1_BEG
	    && irq <= TC90400GDRS_IRQ_FPGA1_END) { /* check irq no.56-71 */

	    spin_lock_irqsave(&tc90400gdrs_irq_fpga_lock, flags);
#ifdef CONFIG_TOSHIBA_TC90400_QFP
	    if (irq <  (TC90400GDRS_IRQ_FPGA1_BEG + 8)) {
	        v = TC90400_RD08(TC90400GDRS_FPGA1_INT_MASK1);
	        v &= ~(1 << (irq - TC90400GDRS_IRQ_FPGA1_BEG));
	        TC90400GDRS_WR08(TC90400GDRS_FPGA1_INT_MASK1, v);
                v = ~(1 << (irq - TC90400GDRS_IRQ_FPGA1_BEG)); /* 0clear */
	        TC90400GDRS_WR08(TC90400GDRS_FPGA1_INT_CLEAR1, v);
	    }
	    else {
	        v = TC90400_RD08(TC90400GDRS_FPGA1_INT_MASK2);
	        v &= ~(1 << (irq - (TC90400GDRS_IRQ_FPGA1_BEG+8)));
	        TC90400GDRS_WR08(TC90400GDRS_FPGA1_INT_MASK2, v);
                v = ~(1 << (irq - (TC90400GDRS_IRQ_FPGA1_BEG+8))); /* 0clear */
	        TC90400GDRS_WR08(TC90400GDRS_FPGA1_INT_CLEAR2, v);
	    }
#else
	    v = TC90400_RD16(TC90400GDRS_FPGA1_INT_MASK);
	    v &= ~(1 << (irq - TC90400GDRS_IRQ_FPGA1_BEG));
	    TC90400GDRS_WR16(TC90400GDRS_FPGA1_INT_MASK, v);
            v = ~(1 << (irq - TC90400GDRS_IRQ_FPGA1_BEG)); /* 0 clear */
	    TC90400GDRS_WR16(TC90400GDRS_FPGA1_INT_CLEAR, v);
#endif /* #ifdef CONFIG_TOSHIBA_TC90400_QFP */
	    spin_unlock_irqrestore(&tc90400gdrs_irq_fpga_lock, flags);
	}
        else {
		TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_EROR,
					     "bad irq=%d\n", irq);
	    panic("\n");
	}

	return;
}


static void tc90400gdrs_irq_fpga_mask_and_ack(unsigned int irq)
{
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_FPGA_MASK,
				     "irq=%d\n", irq);

	tc90400gdrs_irq_fpga_disable(irq);

	return;
}


static void tc90400gdrs_irq_fpga_end(unsigned int irq)
{
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_FPGA_ENDIRQ,
				     "irq=%d\n", irq);

	if (irq < TC90400GDRS_IRQ_FPGA0_BEG
	    || irq > TC90400GDRS_IRQ_FPGA1_END) { /* check irq no.40-55 */
		TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_EROR,
					     "bad irq=%d\n", irq);
		panic("\n");
	}

	if (!(irq_desc[irq].status & (IRQ_DISABLED | IRQ_INPROGRESS))) {
		tc90400gdrs_irq_fpga_enable(irq);
	}

	return;
}


void __init init_IRQ(void)
{
	extern void tc90400_irq_init(void);

	cli();

	tc90400_irq_init();
	tc90400gdrs_irq_fpga_init();

	wbflush();

	return;
}

void tc90400gdrs_irq_dump(char *key)
{
#ifdef TOSHIBA_TC90400GDRS_IRQ_DEBUG
	{
		u32 i, j = 0;
		for (i = 0; i < NR_IRQS; i++) {
			if (strcmp(irq_desc[i].handler->typename, "none")
			    == 0)
				continue;

			if ((i >= 1)
			    && (irq_desc[i - 1].handler->typename ==
				irq_desc[i].handler->typename)) {
				j++;
			} else {
				j = 0;
			}
			TOSHIBA_TC90400GDRS_IRQ_DPRINTK
			    (TOSHIBA_TC90400GDRS_IRQ_INFO,
			     "%s irq=0x%02x/%3d s=0x%08x h=0x%08x a=0x%08x ah=0x%08x d=%1d n=%s/%02d\n",
			     key, i, i, irq_desc[i].status,
			     (u32) irq_desc[i].handler,
			     (u32) irq_desc[i].action,
			     (u32) (irq_desc[i].action ? irq_desc[i].
				    action->handler : 0),
			     irq_desc[i].depth,
			     irq_desc[i].handler->typename, j);
		}
	}
#endif
	return;
}

void tc90400gdrs_irq_dump_pics(char *s)
{
	u32 level0_m;
	u32 level0_s;
	u32 level1_m;
	u32 level1_s;
	u32 level2;
	u32 level2_p;
	u32 level2_s;
	u32 level3_m0;
	u32 level3_s0;
	u32 level3_m1;
	u32 level3_s1;

	if (s == NULL)
		s = "null";

	level0_m = (read_c0_status() & 0x0000ff00) >> 8;
	level0_s = (read_c0_cause() & 0x0000ff00) >> 8;

	level1_m = level0_m;
	level1_s = level0_s & 0x87;

	level2 = TC90400_RD(TC90400_INTVEC);
	level2_p = (((level2 & TC90400_INTVEC_FLAG)) ? 0 : 1);
	level2_s = (((level2 & TC90400_INTVEC_CAUSE_MASK) == TC90400_INTVEC_CAUSE_MASK) ? 0 : (level2 & TC90400_INTVEC_CAUSE_MASK));

#ifdef CONFIG_TOSHIBA_TC90400_QFP
	level3_m0 = TC90400_RD08(TC90400GDRS_FPGA0_INT_MASK)&FPGA0_INTMASK_ALLMASK;
	level3_s0 = TC90400_RD08(TC90400GDRS_FPGA0_INT_STAT)&FPGA0_INTMASK_ALLMASK;
	level3_m1 = TC90400_RD08(TC90400GDRS_FPGA1_INT_MASK1);
        level3_m1 |= TC90400_RD08(TC90400GDRS_FPGA1_INT_MASK2) << 8;
        level3_m1 &= FPGA1_INTMASK_ALLMASK;
	level3_s1 = TC90400_RD08(TC90400GDRS_FPGA1_INT_STAT1);
        level3_s1 |= TC90400_RD08(TC90400GDRS_FPGA1_INT_STAT1) << 8;
        level3_s1 &= FPGA1_INTMASK_ALLMASK;
#else
	level3_m0 = TC90400_RD16(TC90400GDRS_FPGA0_INT_MASK)&FPGA0_INTMASK_ALLMASK;
	level3_s0 = TC90400_RD16(TC90400GDRS_FPGA0_INT_STAT)&FPGA0_INTMASK_ALLMASK;
	level3_m1 = TC90400_RD16(TC90400GDRS_FPGA1_INT_MASK)&FPGA1_INTMASK_ALLMASK;
	level3_s1 = TC90400_RD16(TC90400GDRS_FPGA1_INT_STAT)&FPGA1_INTMASK_ALLMASK;
#endif /* #ifdef CONFIG_TOSHIBA_TC90400_QFP */


	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_INFO,
				     "dump_raw_pic() ");
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_INFO,
				     "cp0:m=0x%02x/s=0x%02x ", level0_m,
				     level0_s);
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_INFO,
				     "cp0:m=0x%02x/s=0x%02x ", level1_m,
				     level1_s);
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_INFO,
				     "pic:e=0x%02x/s=0x%02x ", level2_p,
				     level2_s);
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_INFO,
				     "fpga0:m=0x%02x/s=0x%02x ", level3_m0,
				     level3_s0);
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_INFO,
				     "fpga1:m=0x%02x/s=0x%02x ", level3_m1,
				     level3_s1);
	TOSHIBA_TC90400GDRS_IRQ_DPRINTK(TOSHIBA_TC90400GDRS_IRQ_INFO, "[%s]\n",
				     s);

	return;
}
