/*
 * linux/arch/mips/tc90400/qfp_board01/qfp_board01_irq.c : Reference No : 43PJ292-20050906-QFP_BOARD01-000
 *
 * Internal driver for TC90400
 *
 *  (c) Copyright TOSHIBA CORPORATION SEMICONDUCTOR COMPANY  2003-2005 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 *
 */
/*
 * linux/arch/mips/tx4927/toshiba_rbtx4927/toshiba_rbtx4927_irq.c
 *
 * Toshiba RBTX4927 specific interrupt handlers
 *
 * Author: MontaVista Software, Inc.  source@mvista.com
 *
 * 2003 (c) MontaVista Software, Inc. This file is licensed under
 * the terms of the GNU General Public License version 2. This program 
 * is licensed "as is" without any warranty of any kind, whether express 
 * or implied.
 */

/*
IRQ  Device  
00   TC90400-CP0/00 Software 0
01   TC90400-CP0/01 Software 1
02   TC90400-CP0/02 Multiplexed -- do not use 
03   TC90400-CP0/03 Multiplexed -- do not use 
04   TC90400-CP0/04 Multiplexed -- do not use 
05   TC90400-CP0/05 Multiplexed -- do not use 
06   TC90400-CP0/06 Multiplexed -- do not use 
07   TC90400-CP0/07 Cascade TC90400-PIC

08   TC90400-PIC/00
09   TC90400-PIC/01 EXTINT0(SW4)
10   TC90400-PIC/02 EXTINT1(LAN91C111)  
11   TC90400-PIC/03 EXTINT2
12   TC90400-PIC/04 MPIF-CommonInterface
13   TC90400-PIC/05 MPIF-ATA
14   TC90400-PIC/06 MPIF-NandFlash
15   TC90400-PIC/07 GMBR
16   TC90400-PIC/08 GFX
17   TC90400-PIC/09 VIOU TX IRQ
18   TC90400-PIC/10 SCC ch.0
19   TC90400-PIC/11 SCC ch.1
20   TC90400-PIC/12 USB
21   TC90400-PIC/13 ALOC ch.0
22   TC90400-PIC/14 ALOC ch.1
23   TC90400-PIC/15 DMAC ch.0
24   TC90400-PIC/16 DMAC ch.1
25   TC90400-PIC/17 DMAC ch.2
26   TC90400-PIC/18 DMAC ch.3
27   TC90400-PIC/19 I2C ch.1
28   TC90400-PIC/20 SIO ch.0
29   TC90400-PIC/21 SIO ch.1
30   TC90400-PIC/22 SIO ch.2
31   TC90400-PIC/23 RTC C
32   TC90400-PIC/24 RTC WU
33   TC90400-PIC/25 PIO
34   TC90400-PIC/26 I2C ch.0
35   TC90400-PIC/27 Timer ch.3
36   TC90400-PIC/28 Timer ch.0
37   TC90400-PIC/29 Timer ch.1
38   TC90400-PIC/30 Timer ch.2
39   TC90400-PIC/31 GBUS

*/

#include <linux/config.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/mm.h>
#include <linux/swap.h>
#include <linux/ioport.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/pci.h>
#include <linux/timex.h>
#include <asm/bootinfo.h>
#include <asm/page.h>
#include <asm/bootinfo.h>
#include <asm/io.h>
#include <asm/irq.h>
#include <asm/pci.h>
#include <asm/processor.h>
#include <asm/ptrace.h>
#include <asm/reboot.h>
#include <asm/time.h>
#include <linux/version.h>
#include <linux/bootmem.h>
#include <linux/blk.h>
#include <asm/tc90400/tc90400qfp_board01.h>


#undef TOSHIBA_TC90400QFP_BOARD01_IRQ_DEBUG

#ifdef TOSHIBA_TC90400QFP_BOARD01_IRQ_DEBUG
#define TOSHIBA_TC90400QFP_BOARD01_IRQ_NONE        0x00000000

#define TOSHIBA_TC90400QFP_BOARD01_IRQ_INFO          ( 1 <<  0 )
#define TOSHIBA_TC90400QFP_BOARD01_IRQ_WARN          ( 1 <<  1 )
#define TOSHIBA_TC90400QFP_BOARD01_IRQ_EROR          ( 1 <<  2 )

#define TOSHIBA_TC90400QFP_BOARD01_SETUP_ALL         0xffffffff
#endif


#ifdef TOSHIBA_TC90400QFP_BOARD01_IRQ_DEBUG
static const u32 tc90400qfp_board01_irq_debug_flag =
    (TOSHIBA_TC90400QFP_BOARD01_IRQ_NONE |
     TOSHIBA_TC90400QFP_BOARD01_IRQ_INFO |
     TOSHIBA_TC90400QFP_BOARD01_IRQ_WARN |
     TOSHIBA_TC90400QFP_BOARD01_IRQ_EROR
    );
#endif

#ifdef TOSHIBA_TC90400QFP_BOARD01_IRQ_DEBUG
#define TOSHIBA_TC90400QFP_BOARD01_IRQ_DPRINTK(flag,str...) \
  if ( (tc90400qfp_board01_irq_debug_flag) & (flag) ) \
  { \
    char tmp[100]; \
    sprintf( tmp, str ); \
    printk( "%s(%s:%u)::%s", __FUNCTION__, __FILE__, __LINE__, tmp ); \
  }
#else
#define TOSHIBA_TC90400QFP_BOARD01_IRQ_DPRINTK(flag,str...)
#endif


void __init init_IRQ(void)
{
  extern void tc90400_irq_init(void);

  cli();

  tc90400_irq_init();

  wbflush();

  return;
}

void tc90400qfp_board01_irq_dump(char *key)
{
#ifdef TOSHIBA_TC90400QFP_BOARD01_IRQ_DEBUG
  {
    u32 i, j = 0;
    for (i = 0; i < NR_IRQS; i++) {
      if (strcmp(irq_desc[i].handler->typename, "none") == 0)
	continue;

      if ((i >= 1)
	  && (irq_desc[i - 1].handler->typename ==
	      irq_desc[i].handler->typename)) {
	j++;
      } else {
	j = 0;
      }
      TOSHIBA_TC90400QFP_BOARD01_IRQ_DPRINTK
	(TOSHIBA_TC90400QFP_BOARD01_IRQ_INFO,
	 "%s irq=0x%02x/%3d s=0x%08x h=0x%08x a=0x%08x ah=0x%08x d=%1d n=%s/%02d\n",
	 key, i, i, irq_desc[i].status,
	 (u32) irq_desc[i].handler,
	 (u32) irq_desc[i].action,
	 (u32) (irq_desc[i].action ? irq_desc[i].
		action->handler : 0),
	 irq_desc[i].depth,
	 irq_desc[i].handler->typename, j);
    }
  }
#endif
  return;
}

void tc90400qfp_board01_irq_dump_pics(char *s)
{
  u32 level0_m;
  u32 level0_s;
  u32 level1_m;
  u32 level1_s;
  u32 level2;
  u32 level2_p;
  u32 level2_s;

  if (s == NULL)
    s = "null";

  level0_m = (read_c0_status() & 0x0000ff00) >> 8;
  level0_s = (read_c0_cause() & 0x0000ff00) >> 8;

  level1_m = level0_m;
  level1_s = level0_s & 0x87;

  level2 = TC90400_RD(TC90400_INTVEC);
  level2_p = (((level2 & TC90400_INTVEC_FLAG)) ? 0 : 1);
  level2_s = (((level2 & TC90400_INTVEC_CAUSE_MASK) == TC90400_INTVEC_CAUSE_MASK) ? 0 : (level2 & TC90400_INTVEC_CAUSE_MASK));

  TOSHIBA_TC90400QFP_BOARD01_IRQ_DPRINTK(TOSHIBA_TC90400QFP_BOARD01_IRQ_INFO,
				  "dump_raw_pic() ");
  TOSHIBA_TC90400QFP_BOARD01_IRQ_DPRINTK(TOSHIBA_TC90400QFP_BOARD01_IRQ_INFO,
				  "cp0:m=0x%02x/s=0x%02x ", level0_m,
				  level0_s);
  TOSHIBA_TC90400QFP_BOARD01_IRQ_DPRINTK(TOSHIBA_TC90400QFP_BOARD01_IRQ_INFO,
				  "cp0:m=0x%02x/s=0x%02x ", level1_m,
				  level1_s);
  TOSHIBA_TC90400QFP_BOARD01_IRQ_DPRINTK(TOSHIBA_TC90400QFP_BOARD01_IRQ_INFO,
				  "pic:e=0x%02x/s=0x%02x ", level2_p,
				  level2_s);
  TOSHIBA_TC90400QFP_BOARD01_IRQ_DPRINTK(TOSHIBA_TC90400QFP_BOARD01_IRQ_INFO, "[%s]\n",s);

  return;
}
