/*
 * linux/arch/mips/zboot/include/tc90400qfp_board01.h : Reference No : 43PJ292-20050906-QFP_BOARD01-000
 *
 * Internal driver for TC90400
 *
 *  (c) Copyright TOSHIBA CORPORATION SEMICONDUCTOR COMPANY  2003-2005 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 *
 */

#if !defined(_TC90400QFP_BOARD01_H_)
#define _TC90400QFP_BOARD01_H_

/* memory mapping */
#define CE0_ADDR	0x1f800000
#define CE1_ADDR	0x18000000

/***************** Register default values ******************/

/* EBIF register */
#define RBA_MASK		0x07f00000

#define RBA(VAL)		( (VAL & RBA_MASK))	/* ROM control base address */
#define RPM(VAL)		( (VAL & 0x03) << 18)	/* ROM control page mode page size */
#define RPWT(VAL)		( (VAL & 0x03) << 16)	/* ROM control page mode wait time */ 
#define RWT(VAL)		( (VAL & 0x0f) << 12)	/* ROM control normal mode wait time */
#define RCS(VAL)		( (VAL & 0x0f) << 8)	/* ROM controlchannel size 0=1MB 1=2MB 2=4MB 3=8MB 4=16MB 5=32MB 6=64MB 7=128MB */
#define BUS16(VAL)		( (VAL & 0x01) << 7)	/* ROM control bus width 0=8bit 1=16bit */
#define RDY(VAL)		( (VAL & 0x01) << 6)	/* ROM control ready input active */
#define RBC(VAL)		( (VAL & 0x01) << 5)	/* ROM byte control */
#define RME(VAL)		( (VAL & 0x01) << 3)	/* ROM control master enable */
#define RSHWT(VAL)		( (VAL & 0x07) << 0)	/* ROM control setup/hold wait time */

/* ----- QFP ----- */
#if (BOOT == 1)		/* booting from NOR FLASH */
    #define ERCCR0_DEFAULT (RBA(CE0_ADDR)|RPM(0)|RPWT(0)|RWT(4)|RCS(3)|BUS16(0)|RDY(0)|RBC(0)|RME(1)|RSHWT(0))
    #define ERCCR1_DEFAULT (RBA(CE1_ADDR)|RPM(0)|RPWT(0)|RWT(4)|RCS(5)|BUS16(0)|RDY(0)|RBC(0)|RME(1)|RSHWT(1))
    #define ERCCR2_DEFAULT 0	/* Not Used */
    #define ERCCR3_DEFAULT 0	/* Not Used */
#endif	/* #if (BOOT == 1) */


/* ZTEST register */
#define _ZTEST_CFSH3_DEFAULT_VAL  	0x00000000

/* PIO(LED) register */
#define _PIO_LEDMASK_VAL  	        0x0001e000


#endif	/* _TC90400QFP_BOARD01_H_ */
