/*
 * linux/include/asm-mips/tc90400/tc90400_drv.h : Reference No : 43PJ292-20050906-QFP_BOARD01-000
 *
 * Header file for user-space enhance driver for TC90400
 *
 *  (c) Copyright TOSHIBA CORPORATION SEMICONDUCTOR COMPANY  2003-2005
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your potion) any lator version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 *
 */

#ifndef ___TC90400_DRV_H
#define ___TC90400_DRV_H

#ifdef __cplusplus
extern "C" {
#endif
  
#define TC90400_OK                          0
  
  
  /* TC90400 Enhanced Driver Minor number */
#define TC90400_ENH_DEV                     "tc90400_dev"
#define TC90400_ENH_MAJOR                   254  /* TC90400 device */
#define TC90400_ENH_MMAP_MINOR              0    /* mmap device */
#define TC90400_ENH_INT_MINOR_MIN           1    /* min interrupt device */
#define TC90400_ENH_INT_MINOR_MAX           15   /* max interrupt device */


  /* TC90400 Driver Memory area constants */
#define TC90400_SDRAM_START_PHYS       0x00001000UL
#define TC90400_SDRAM_START_OFF        0x00001000UL
//#define TC90400_SDRAM_SIZE             0x017ff000UL
#define TC90400_SDRAM_SIZE             0x01fff000UL
//#define TC90400_SDRAM_SIZE             0x03fff000UL /* 64MB */

#define TC90400_MBUS_START_PHYS        0x17400000UL
#define TC90400_MBUS_START_OFF         0x17400000UL
#define TC90400_MBUS_SIZE              0x00140000UL

#define TC90400_EXTB1_START_PHYS       0x18000000UL
#define TC90400_EXTB1_START_OFF        0x18000000UL
#define TC90400_EXTB1_SIZE             0x04000000UL

#define TC90400_ZTEST_START_PHYS       0x1e01c000UL
#define TC90400_ZTEST_START_OFF        0x1e01c000UL
#define TC90400_ZTEST_SIZE             0x00004000UL

#define TC90400_EXTB2_START_PHYS       0x1f000000UL
#define TC90400_EXTB2_START_OFF        0x1f000000UL
#define TC90400_EXTB2_SIZE             0x01000000UL

  /* TC90400 Memory area constants table structure */
  typedef struct {
    char          *pAreaName;
    unsigned long startPhys;
    unsigned long startOff;
    unsigned long areaSize;
  } tMapParm;

  /* Ioctl SystemCall command */
#define IOCTL_INTDRV_INTENABLE      0x00
#define IOCTL_INTDRV_INTDISABLE     0x01
#define IOCTL_INTDRV_CANCEL         0x02
  /* Ioctl SystemCall test command */
#define IOCTL_INTDRV_DUMP_INFO      1010
#define IOCTL_INTDRV_READ_KSEG      1011
#define IOCTL_INTDRV_WRITE_KSEG     1012

#ifdef __cplusplus
}
#endif
#endif /* TC90400_DRV_H */
