/*
 * linux/include/asm-mips/tc90400/tc90400_mips.h : Reference No : 43PJ292-20050906-QFP_BOARD01-000
 *
 * Internal driver for TC90400
 *
 *  (c) Copyright TOSHIBA CORPORATION SEMICONDUCTOR COMPANY  2003-2005 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 *
 */
#ifndef __ASM_TC90400_TC90400_MIPS_H
#define __ASM_TC90400_TC90400_MIPS_H

#ifndef __ASSEMBLY__

static inline void asm_wait(void)
{
	__asm__(".set\tmips3\n\t"
		"wait\n\t"
		".set\tmips0");
}

#define reg_rd08(r)    ((u8 )(*((vu8 *)(r))))
#define reg_rd16(r)    ((u16)(*((vu16*)(r))))
#define reg_rd32(r)    ((u32)(*((vu32*)(r))))
#define reg_rd64(r)    ((u64)(*((vu64*)(r))))

#define reg_wr08(r,v)  ((*((vu8 *)(r)))=((u8 )(v)))
#define reg_wr16(r,v)  ((*((vu16*)(r)))=((u16)(v)))
#define reg_wr32(r,v)  ((*((vu32*)(r)))=((u32)(v)))
#define reg_wr64(r,v)  ((*((vu64*)(r)))=((u64)(v)))

typedef volatile __signed char vs8;
typedef volatile unsigned char vu8;

typedef volatile __signed short vs16;
typedef volatile unsigned short vu16;

typedef volatile __signed int vs32;
typedef volatile unsigned int vu32;

typedef  s8  s08;
typedef vs8 vs08;

typedef  u8  u08;
typedef vu8 vu08;


#if (_MIPS_SZLONG == 64)

typedef volatile __signed__ long vs64;
typedef volatile unsigned long vu64;

#else

typedef volatile __signed__ long long vs64;
typedef volatile unsigned long long vu64;

#endif

#endif

#endif /* __ASM_TC90400_TC90400_MIPS_H */
