/*
 * linux/include/asm-mips/tc90400/tc90400_pd.h : Reference No : 43PJ292-20050906-QFP_BOARD01-000
 *
 * Header file for user-space enhance driver for TC90400
 *
 *  (c) Copyright TOSHIBA CORPORATION SEMICONDUCTOR COMPANY  2003-2005
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your potion) any lator version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 *
 */

#ifndef ___TC90400_PD_H
#define ___TC90400_PD_H

#ifdef __cplusplus
extern "C" {
#endif
  
#define TC90400PD_OK                0

  /* TC90400 PowerDown Driver infomation */
#define TC90400_PD_DEV              "tc90400_powerdown_dev"
#define TC90400_PD_MAJOR            253  /* major */
#define TC90400_PD_MINOR            0    /* minor */

  /* Ioctl SystemCall command */
#define IOCTL_PD_HALT               0x01
#define IOCTL_PD_COCR_W             0x02
#define IOCTL_PD_COCR_R             0x03
#define IOCTL_PD_INT_MASK           0x04
#define IOCTL_PD_INT_UNMASK         0x05
#define IOCTL_PD_RSTCR              0x06

  /* TC90400 Power-Down device define */
#define PD_RSTCR_VALUE              0x0001c000 /* TSP/ASP/AMP */
#define INTLVL_REGNUM               8

#ifdef __cplusplus
}
#endif
#endif /* TC90400_PD_H */
