/*
 * linux/include/asm-mips/tc90400/tc90400qfp_board01.h : Reference No : 43PJ292-20050906-QFP_BOARD01-000
 *
 * Internal driver for TC90400 qfp_board01
 *
 *  (c) Copyright TOSHIBA CORPORATION SEMICONDUCTOR COMPANY  2003-2005 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 *
 */
#ifndef __ASM_TC90400_TC90400QFP_BOARD01_H
#define __ASM_TC90400_TC90400QFP_BOARD01_H

#include <asm/tc90400/tc90400.h>
#ifdef CONFIG_PCI
#include <asm/tc90400/tc90400_pci.h>
#endif


#ifdef CONFIG_PCI
#define TC90400QFP_BOARD01_ISA_IO_OFFSET TC90400_PCIIO
#else
#define TC90400QFP_BOARD01_ISA_IO_OFFSET 0
#endif


/*
 * ethernet controller register physical address
*/
#define SMC91111CNT_BASE                0x300
/* debug ehternet controller on mainboard */
#define TC90400QFP_BOARD01_ETH_PHYS_BASE  (0x180c0000 + SMC91111CNT_BASE)


/*
 * NorFlash on QFP_BOARD01board define
*/
#define TC90400QFP_BOARD01_FLASH_NAME   "TC90400QFP_BOARD01 NOR-FLASH"
#define TC90400_BUSWIDTH                1 /* 8bit  */
#define FLASH_1MB         0x00100000	  /* 1MByte */
#define FLASH_3MB         0x00300000	  /* 3MByte */
#define FLASH_4MB         0x00400000	  /* 4MByte */
#define FLASH_8MB         0x00800000	  /* 8MByte */

struct tc90400qfp_board01_norflash {
    unsigned long flash_addr;
    unsigned long flash_size;
    unsigned long flash_partnum;
};

#endif /* __ASM_TC90400_TC90400QFP_BOARD01_H */
